1 #!/bin/sh -- # no runable script, just for vi
3 # we all like colorful messages
4 CERROR
="\e[1;31m" # red
5 CWARNING
="\e[1;33m" # yellow
6 CMSG
="\e[1;32m" # green
7 CINFO
="\e[1;96m" # light blue
8 CDEBUG
="\e[1;94m" # blue
9 CNORMAL
="\e[0;39m" # default system console color
10 CDONE
="\e[1;32m" # green
11 CPASS
="\e[1;32m" # green
12 CFAIL
="\e[1;31m" # red
13 CCMD
="\e[1;35m" # pink
15 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
18 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgtest
() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28 msgfail
() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
30 # enable / disable Debugging
31 MSGLEVEL
=${MSGLEVEL:-3}
32 if [ $MSGLEVEL -le 0 ]; then
35 if [ $MSGLEVEL -le 1 ]; then
39 if [ $MSGLEVEL -le 2 ]; then
43 if [ $MSGLEVEL -le 3 ]; then
47 if [ $MSGLEVEL -le 4 ]; then
52 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
53 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
54 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
55 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
56 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
59 echo "${CDONE}DONE${CNORMAL}" >&2;
64 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
65 if [ -f .
/aptconfig.conf
]; then
66 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
68 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
71 aptconfig
() { runapt apt
-config $
*; }
72 aptcache
() { runapt apt
-cache $
*; }
73 aptget
() { runapt apt
-get $
*; }
74 aptftparchive
() { runapt apt
-ftparchive $
*; }
77 local TMPWORKINGDIRECTORY
=$(mktemp -d)
78 local TESTDIR
=$(readlink -f $(dirname $0))
79 msgninfo
"Preparing environment for ${CCMD}$0${CINFO} in ${TMPWORKINGDIRECTORY}… "
80 BUILDDIRECTORY
="${TESTDIR}/../../build/bin"
81 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
82 local OLDWORKINGDIRECTORY
=$(pwd)
83 trap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
84 cd $TMPWORKINGDIRECTORY
85 mkdir rootdir aptarchive
87 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d var
/cache
88 mkdir -p var
/log
/apt var
/lib
/apt
89 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
90 local STATUSFILE
=$(echo "$(basename $0)" | sed 's/^test-/status-/')
91 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
92 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
94 touch var/lib/dpkg/status
96 touch var/lib/apt/extended_states var/lib/dpkg/available
98 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
100 local PACKAGESFILE=$(echo "$(basename $0)" | sed 's/^test-/Packages-/')
101 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
102 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive
/Packages
104 touch aptarchive
/Packages
106 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
107 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
108 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
109 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
110 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
111 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
112 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
113 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
114 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
119 configarchitecture
() {
120 local CONFFILE
=rootdir
/etc
/apt
/apt.conf.d
/01multiarch.conf
121 echo "APT::Architecture \"$1\";" > $CONFFILE
123 while [ -n "$1" ]; do
124 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
129 buildsimplenativepackage
() {
133 local RELEASE
="${4:-unstable}"
134 local DEPENDENCIES
="$5"
135 local DESCRIPTION
="$6"
136 local SECTION
="${7:-others}"
138 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
141 DISTSECTION
="$(echo "$SECTION" | cut -d'/' -f 1)"
143 msgninfo
"Build package ${CCMD}${NAME}=${VERSION}/${RELEASE}${CINFO}… "
144 local BUILDDIR
=incoming
/${NAME}-${VERSION}
145 mkdir -p ${BUILDDIR}/debian
/source
147 echo "* most suckless software product ever" > FEATURES
148 test -e debian
/copyright
|| echo "Copyleft by Joe Sixpack $(date +%Y)" > debian
/copyright
149 test -e debian
/changelog
|| echo "$NAME ($VERSION) $RELEASE; urgency=low
153 -- Joe Sixpack <joe@example.org> $(date -R)" > debian
/changelog
154 test -e debian
/control
|| echo "Source: $NAME
157 Maintainer: Joe Sixpack <joe@example.org>
158 Build-Depends: debhelper (>= 7)
159 Standards-Version: 3.9.1
162 Architecture: $ARCH" > debian
/control
163 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian
/control
164 if [ -z "$DESCRIPTION" ]; then
165 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
166 If you find such a package installed on your system,
167 YOU did something horribly wrong! They are autogenerated
168 und used only by testcases for APT and surf no other propose…" >> debian
/control
170 echo "Description: $DESCRIPTION" >> debian
/control
172 test -e debian
/compat
|| echo "7" > debian
/compat
173 test -e debian
/source
/format
|| echo "3.0 (native)" > debian
/source
/format
174 test -e debian
/rules
|| cp /usr
/share
/doc
/debhelper
/examples
/rules.tiny debian
/rules
175 local BUILT
="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
176 local PKGS
="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
177 local SRCS
="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._-]*$')"
180 echo "pool/${PKG}" >> .
/incoming
/${RELEASE}.
${DISTSECTION}.pkglist
183 echo "pool/${SRC}" >> .
/incoming
/${RELEASE}.
${DISTSECTION}.srclist
190 if [ -d incoming
]; then
191 buildaptarchivefromincoming $
*
193 buildaptarchivefromfiles $
*
197 createaptftparchiveconfig
() {
198 local ARCHS
="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
200 ArchiveDir "' >> ftparchive.conf
201 echo -n $(readlink -f .) >> ftparchive.conf
203 CacheDir "' >> ftparchive.conf
204 echo -n $(readlink -f ..) >> ftparchive.conf
206 FileListDir "' >> ftparchive.conf
207 echo -n $(readlink -f pool/) >> ftparchive.conf
211 Packages::Compress ". gzip bzip2 lzma";
212 Sources::Compress ". gzip bzip2 lzma";
213 Contents::Compress ". gzip bzip2 lzma";
217 SrcDirectory "pool/";
223 Label "apttestcases";
225 Description "repository with dummy packages";
226 Architectures "' >> ftparchive.conf
227 echo -n "$ARCHS" >> ftparchive.conf
231 };' >> ftparchive.conf
232 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
233 echo -n 'tree "dists/' >> ftparchive.conf
234 echo -n "$DIST" >> ftparchive.conf
236 Architectures "' >> ftparchive.conf
237 echo -n "$ARCHS" >> ftparchive.conf
239 FileList "' >> ftparchive.conf
240 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
242 SourceFileList "' >> ftparchive.conf
243 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
245 Sections "' >> ftparchive.conf
246 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
248 };' >> ftparchive.conf
252 buildaptftparchivedirectorystructure
() {
253 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
254 for DIST
in $DISTS; do
255 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
256 for SECTION
in $SECTIONS; do
257 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
258 for ARCH
in $ARCHS; do
259 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
261 mkdir -p dists
/${DIST}/${SECTION}/source
262 mkdir -p dists
/${DIST}/${SECTION}/i18n
267 buildaptarchivefromincoming
() {
268 msginfo
"Build APT archive for ${CCMD}$0${CINFO} based on incoming packages…"
270 [ -e pool
] || ln -s ..
/incoming pool
271 [ -e ftparchive.conf
] || createaptftparchiveconfig
272 [ -e dists
] || buildaptftparchivedirectorystructure
273 msgninfo
"\tGenerate Packages, Sources and Contents files… "
274 aptftparchive
-qq generate ftparchive.conf
276 msgninfo
"\tGenerate Release files… "
277 for dir
in $(find ./dists -mindepth 1 -maxdepth 1 -type d); do
278 aptftparchive
-qq release
$dir | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
284 buildaptarchivefromfiles
() {
285 msginfo
"Build APT archive for ${CCMD}$0${CINFO} based on prebuild files…"
287 if [ -f Packages
]; then
288 msgninfo
"\tPackages file… "
289 cat Packages
| gzip > Packages.gz
290 cat Packages
| bzip2 > Packages.bz2
291 cat Packages
| lzma
> Packages.lzma
294 if [ -f Sources
]; then
295 msgninfo
"\tSources file… "
296 cat Sources
| gzip > Sources.gz
297 cat Sources
| bzip2 > Sources.bz2
298 cat Sources
| lzma
> Sources.lzma
301 msgninfo
"\tRelease file… "
302 aptftparchive
-qq release .
| sed -e '/0 Release$/ d' > Release
# remove the self reference
307 setupdistsaptarchive
() {
308 local APTARCHIVE
=$(readlink -f ./aptarchive)
309 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
310 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
311 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
312 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
313 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
314 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
315 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
320 setupflataptarchive
() {
321 local APTARCHIVE
=$(readlink -f ./aptarchive)
322 if [ -f ${APTARCHIVE}/Packages
]; then
323 msgninfo
"\tadd deb sources.list line… "
324 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
327 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
329 if [ -f ${APTARCHIVE}/Sources
]; then
330 msgninfo
"\tadd deb-src sources.list line… "
331 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
334 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
340 if [ -e aptarchive
/dists
]; then
349 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
350 if [ -n "$DIFFTEXT" ]; then
360 local COMPAREFILE
=$(mktemp)
361 echo "$1" > $COMPAREFILE
363 msgtest
"Test for equality of" "$*"
364 $
* 2>&1 | diff $COMPAREFILE - && msgpass
|| msgfail
369 local COMPAREFILE1
=$(mktemp)
370 local COMPAREFILE2
=$(mktemp)
371 local COMPAREAGAINST
=$(mktemp)
372 echo "$1" > $COMPAREFILE1
373 echo "$2" > $COMPAREFILE2
375 msgtest
"Test for equality OR of" "$*"
376 $
* 2>&1 1> $COMPAREAGAINST
377 (diff $COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
378 diff $COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
379 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(diff $COMPAREFILE1 $COMPAREAGAINST)" \
380 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(diff $COMPAREFILE2 $COMPAREAGAINST)" &&
382 rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST
386 local VIRTUAL
="N: Can't select versions from package '$1' as it purely virtual"
389 while [ -n "$1" ]; do
391 N: Can't select versions from package '$1' as it purely virtual"
392 PACKAGE
="${PACKAGE} $1"
395 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
397 N: No packages found"
398 local COMPAREFILE
=$(mktemp)
399 local ARCH
=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
400 eval `apt-config shell ARCH APT::Architecture`
401 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
402 aptcache show
$PACKAGE 2>&1 | diff $COMPAREFILE - && msgpass
|| msgfail
407 msgtest
"Test for non-existent packages" "apt-cache show $*"
408 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
409 if [ -n "$SHOWPKG" ]; then